; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
; 
;
;   This example shows why the xchg reg,[mem] and xchg [mem],reg
;   instructions should be avoided in code where speed matters.
;
; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
; 
    .data
      mem dd 0
    .code
; 
start:
; 
    invoke Sleep, 300
    
    REPEAT 3

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        xchg ecx, edx
      ENDM
    counter_end
    print ustr$(eax)," cycles, (xchg reg,reg)*100",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        xchg edx, [ebx]
      ENDM
    counter_end
    print ustr$(eax)," cycles, (xchg reg,mem)*100",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        xchg [ebx], edx
      ENDM
    counter_end
    print ustr$(eax)," cycles, (xchg mem,reg)*100",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        mov eax, edx
        mov edx, ecx
        mov ecx, eax
      ENDM
    counter_end
    print ustr$(eax)," cycles, (exchange reg,reg)*100 using mov",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        mov eax, [ebx]
        mov [ebx], edx
        mov edx, eax
      ENDM
    counter_end
    print ustr$(eax)," cycles, (exchange reg,mem)*100 using mov",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        push edx
        mov edx, [ebx]
        pop [ebx]
      ENDM
    counter_end

    print ustr$(eax)," cycles, (exchange reg,mem)*100 using pop [ebx]",13,10
     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        push [ebx]
        mov [ebx], edx
        pop edx
      ENDM
    counter_end
    print ustr$(eax)," cycles, (exchange reg,mem)*100 using push [ebx]",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        and mem, 0
      ENDM
    counter_end
    print ustr$(eax)," cycles, (and mem)*100",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        or mem, -1
      ENDM
    counter_end
    print ustr$(eax)," cycles, (or mem)*100",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        inc dword ptr [ebx]
      ENDM
    counter_end
    print ustr$(eax)," cycles, (inc mem)*100",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        mov eax, mem
        inc eax
        mov mem, eax
      ENDM
    counter_end
    print ustr$(eax)," cycles, (inc mem)*100 using eax",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100/2
        inc dword ptr [ebx]
        dec dword ptr [ebx]
      ENDM
    counter_end
    print ustr$(eax)," cycles, (inc dec mem)*100",13,10

     counter_begin 1000, HIGH_PRIORITY_CLASS
      lea ebx, mem
      REPEAT 100
        inc mem
      ENDM
    counter_end
    print ustr$(eax)," cycles, (inc mem)*100",13,10,13,10
     ENDM

    inkey "Press any key to exit..."
    exit
; 
end start

OPT_Tmp2Asm	1
